;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Main
;##################################################################################

   .area _DATA
   .area _CODE

   .include "cpctelera.h.s"
   .include "cpct_functions.inc"
   .include "manager/game.inc"
   .include "manager/menu.inc"
   .include "system/render.inc"

   .globl _main_music
   .globl _effects

;##################################################################################

_main::
   
   ; call cpct_disableFirmware_asm
   call set_int_handler
   ; Set video mode 0 (byte = 2 px)
   halt
   ld c,#0
   call cpct_setVideoMode_asm
   ; Set black border
   cpctm_setBorder_asm HW_BLACK
   ld de,#_main_music
   call cpct_akp_musicInit_asm
   ld de,#_effects
   call cpct_akp_SFXInit_asm
   loop_game:
      ;; Menu principal
      call man_menu_startmenu
      cp #4
      jr z,end_game_loop
      call man_game_init
      
   jr loop_game

   end_game_loop:

ret

   