;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Animations_Manager
;##################################################################################
    .area _CODE

    .include "manager/entity.inc"
    .include "sprites/assets.inc"
    .include "cpct_functions.inc"
    .include "cpctelera.h.s"
    .include "macros.inc"
    .include "manager/game.inc"
    .include "manager/audio.inc"

    .globl _death_effect


;##################################################################################

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Animations
    ;; Enemy ballon
        _balloon_small::
            .dw _spr_desinflado_0
            .dw _spr_desinflado_1
            .dw _spr_desinflado_2
            .dw _spr_desinflado_3
            .dw 0x0000
            .dw _balloon_small

        _balloon_big:
            .dw _spr_balloon_00
            .dw _spr_balloon_01
            .dw _spr_balloon_02
            .dw _spr_balloon_03
            .dw _spr_balloon_04
            .dw _spr_balloon_05
            .dw _spr_balloon_06
            .dw _spr_balloon_07
            .dw _spr_balloon_08
            .dw _spr_balloon_09
            .dw _spr_balloon_10
            .dw _spr_balloon_11
            .dw 0x0000
            .dw _balloon_big+10

        _balloon_array::
            .dw 0x0000
            .dw _balloon_small
            .dw _balloon_big


    ;; Enemy Shot
        _shoter_up:
            .dw _spr_enemyshoter_14
            .dw _spr_enemyshoter_06
            .dw _spr_enemyshoter_07
            .dw _spr_enemyshoter_06
            .dw _spr_enemyshoter_08
            .dw 0x0000
            .dw _shoter_up+2

        _shoter_down:
            .dw _spr_enemyshoter_15
            .dw _spr_enemyshoter_09
            .dw _spr_enemyshoter_10
            .dw _spr_enemyshoter_09
            .dw _spr_enemyshoter_11
            .dw 0x0000
            .dw _shoter_down+2

        _shoter_right::
            .dw _spr_enemyshoter_12
            .dw _spr_enemyshoter_00
            .dw _spr_enemyshoter_01
            .dw _spr_enemyshoter_00
            .dw _spr_enemyshoter_02
            .dw 0x0000
            .dw _shoter_right+2

        _shoter_left:
            .dw _spr_enemyshoter_13
            .dw _spr_enemyshoter_03
            .dw _spr_enemyshoter_04
            .dw _spr_enemyshoter_03
            .dw _spr_enemyshoter_05
            .dw 0x0000
            .dw _shoter_left+2

        _shoter_array::
            .dw 0x0000
            .dw _shoter_right
            .dw _shoter_left
            .dw _shoter_up
            .dw _shoter_down
            .dw _shoter_right
            .dw _shoter_left
            .dw _shoter_up
            .dw _shoter_down

        _shot::
            .dw _spr_shot_0
            .dw _spr_shot_1
            .dw _spr_shot_2
            .dw _spr_shot_3
            .dw 0x0000
            .dw _shot
        _shot_array::
            .dw 0x0000
            .dw _shot
            .dw _shot
            .dw _shot
            .dw _shot

    ;; Enemy lado
        _enemy_up:
            .dw _spr_lado_a_lado_06
            .dw _spr_lado_a_lado_07
            .dw _spr_lado_a_lado_08
            .dw 0x0000
            .dw _enemy_up
        _enemy_down:
            .dw _spr_lado_a_lado_09
            .dw _spr_lado_a_lado_10
            .dw _spr_lado_a_lado_11
            .dw 0x0000
            .dw _enemy_down
        _enemy_right::
            .dw _spr_lado_a_lado_00
            .dw _spr_lado_a_lado_01
            .dw _spr_lado_a_lado_02
            .dw 0x0000
            .dw _enemy_right

        _enemy_left:
            .dw _spr_lado_a_lado_03
            .dw _spr_lado_a_lado_04
            .dw _spr_lado_a_lado_05
            .dw 0x0000
            .dw _enemy_left
        _enemy_array::
            .dw 0x0000
            .dw _enemy_right
            .dw _enemy_left
            .dw _enemy_up
            .dw _enemy_down

    ;; WORM
        _worm_damage:
            .dw _spr_damage_0
            .dw _spr_damage_1
            .dw _spr_damage_2
            .dw _spr_damage_3
            .dw 0x0000
            .dw _worm_damage

        _worm_death:
            .dw _spr_death_0
            .dw _spr_death_1
            .dw _spr_death_2
            .dw _spr_death_3
            .dw _spr_death_4
            .dw _spr_death_5
            .dw _spr_death_6
            .dw 0x0000
            .dw _worm_death

        _worm_idle::
            .dw _spr_player_16
            .dw _spr_player_17
            .dw 0x0000
            .dw _worm_idle

        _worm_up::
            .dw _spr_player_08
            .dw _spr_player_09
            .dw _spr_player_10
            .dw _spr_player_11
            .dw 0x0000
            .dw _worm_up

        _worm_down::
            .dw _spr_player_12
            .dw _spr_player_13
            .dw _spr_player_14
            .dw _spr_player_15
            .dw 0x0000
            .dw _worm_down

        _worm_right::
            .dw _spr_player_00
            .dw _spr_player_01
            .dw _spr_player_02
            .dw _spr_player_03
            .dw 0x0000
            .dw _worm_right

        _worm_left::
            .dw _spr_player_04
            .dw _spr_player_05
            .dw _spr_player_06
            .dw _spr_player_07
            .dw 0x0000
            .dw _worm_left

        _worm_array::
            .dw _worm_idle
            .dw _worm_right
            .dw _worm_left
            .dw _worm_up
            .dw _worm_down
            .dw _worm_damage
            .dw _worm_death
            .dw _worm_damage
            .dw _worm_damage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UPDATE ANIMATIONS
    sys_animation_update::
        ld bc, #sys_animation_update_one_entity
        ld e, #e_cmp_animated
        call man_entity_forall_matching
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UPDATE ANIMATION FOR ONE ENTITY
    sys_animation_update_one_entity::

        call calculateAnimStatus

        ;; Ver si la animacion es igual a la anterior
        ld a,e_anim_st(ix)
        cp b
        jr z,_continueAnim
        _newAnimationStatus:
        ld e_anim_st(ix),b

        call man_animations_getAnimHL
        ld e_animation(ix),l
        ld e_animation+1(ix),h
        ld e_anim_cnt(ix),#1

        _continueAnim:

        ld a,e_anim_cnt(ix)
        dec a
        cp #0       ;; si no es 0, esperamos
        jr nz, wait_anim
        ld a,e_anim_cnt+1(ix)
        ld e_anim_cnt(ix),a

        ld e,e_animation(ix)        ;; DE = Siguiente paso animacion
        ld d,e_animation+1(ix)

        ex de,hl                    ;; Guarda en HL DE para usarlo con la siguiente animacion
        _return2Anim:

        ld c,(hl)
        inc hl                      ;; BC Next sprite
        ld b,(hl)
        inc hl                      ;; Siguiente animacion

        ld a,c
        or b                        ;; Comprobar si es 0 para reiniciar animacion 
        jr z,_resetAnim
        ld e_animation(ix),l
        ld e_animation+1(ix),h

        ld e_sprite(ix),c
        ld e_sprite+1(ix),b

        ex de,hl
        ret
        wait_anim:
        ld e_anim_cnt(ix),a

        ret

        _resetAnim:
            ;; Vuelve a empezar la animacion
            ld a,(hl)
            inc hl
            ld h,(hl)
            ld l,a

            ld a,e_type(ix)
            cp #e_type_player
            jr nz,_return2Anim
                ld a,e_anim_st(ix)
                cp #5
                jr nz,restart_level_post_animation
                    call man_game_getSpawnPlayer
                    jp _newAnimationStatus
                restart_level_post_animation:
                cp #6
                jr nz,_return2Anim
                    ld a,#1
                    ld (_game_STATUS),a
                    jp _newAnimationStatus

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Calcular animacion actual
    calculateAnimStatus:

        ld a,e_dir(ix)
        or a
        jr nz,_nozero
            ld b,a
            jp check_shoter
            
        _nozero:
        jp m,_negative 
        _positive:
            cp #1
            jr nz,set_up_anim
                ;; Set right
                ld b,#1
                jp check_shoter

            set_up_anim:
                cp #2
                jr nz,anim_5
                ld b,#3
                jp check_shoter
            anim_5:
                cp #3
                jr nz,anim_6
                ld b,#5
                ret
                anim_6:
                ld b,#6
            ret

                
        _negative:
            cp #-1
            jr nz, set_down_anim
                ;; Set left
                ld b,#2
                jp check_shoter
            set_down_anim:
                ld b,#4

        check_shoter:
            ld a,e_type(ix)
            cp #e_type_enemy_shoter
            ret nz
                ld a,e_action+1(ix)
                or a
                ret nz
                ;; cambia animacion
                ld a,#4
                add b
                ld b,a

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Obtener animacion 

    man_animations_getAnimHL:
        ld l,e_anim_table(ix)
        ld h,e_anim_table+1(ix)
        
        ld a,b
        add a
        add_hl_a

        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Set animation player damage
    man_animation_setDamage::

        ld a,(_player_hp)
        or a
        jr nz,set_damage
            ; set death
            ld a,#4
            ld e_dir(ix),a
            ld de,#_death_effect
            call cpct_akp_musicInit_asm
            
            ret
        set_damage:
            ld a,#3
            ld e_dir(ix),a
            call man_audio_playDamage

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;