;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
;   Entity Include
;       Definition of functions
;##################################################################################


;#####################################################
;   GLOBAL SYMBOLS
    .globl man_entity_create
    ; .globl man_entity_destroy
    ; .globl man_entity_forall
    .globl man_entity_forall_matching
    ; .globl man_entity_forall_pairs_matching
    ; .globl man_entity_get_from_idx
    .globl man_entity_set4destruction
    .globl man_entity_update
    .globl _last_elem_ptr
    .globl get_Player_entity_IX
    .globl man_destroy_all_entities_no_Player
    .globl _entities
    .globl man_entity_calculateShot

;#####################################################

;; Maximun number of entities
MAX_ENTITIES = 20

MAX_HP_PLAYER = 3

;#####################################################
; Entity types

    e_type_invalid          = #0x00
    e_type_player           = #0x01
    e_type_enemy_shoter     = #0x02
    e_type_shot             = #0x03
    e_type_enemy_long        = #0x04
    e_type_bigshot          = #0x05
    e_type_enemy_lado       = #0x06
    e_type_enemy_balloon    = #0x07
    e_type_dead             = #0x80
    e_type_default          = #0x7F
    
;#####################################################

;#####################################################
; Entity components

    e_cmp_render            = #0b00000001
    e_cmp_ai                = #0b00000100
    e_cmp_render_raster     = #0b00000010
    e_cmp_animated          = #0b00001000
    e_cmp_movable           = #0b00010000
    e_cmp_destroyable       = #0b01000000
    e_cmp_default           = #0b00000000

;#####################################################

;#####################################################
; Entity array
    e_type      = 0
    e_cmps      = 1
    e_posX      = 2
    e_posY      = 3
    e_VX        = 4
    e_VY        = 5
    e_dir       = 6
    e_width     = 7
    e_height    = 8
    e_sprite    = 9
    e_previous  = 11
    e_AI        = 13
    e_action    = 15
    e_animation = 17
    e_anim_st   = 19
    e_anim_cnt  = 20
    e_anim_table= 22
    e_sizeof    = 24
;#####################################################

;;; ANIM STATUS

e_anim_idle = 0x00
e_anim_up   = 0x01

;#####################################################
; ENTITY STRUCTURE
;   Tipo
;   Componentes
;   X, Y
;   VX, VY
;   Orientacion
;   W, H
;   Sprite
;   Vida
;   Dano
;   IA
;#####################################################

