;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Demo_Manager
;##################################################################################
    .area _CODE

    .include "cpctelera.h.s"
    .include "cpct_functions.inc"
    .include "system/input.inc"
    .include "system/render.inc"
    .include "manager/game.inc"
    .include "system/animation.inc"
    .include "macros.inc"

;##################################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Menu Principal

    init_text:: .asciz "PLAY"
    init_text2:: .asciz "CONTROLS"
    init_text3:: .asciz "CREDITS"
    init_text4:: .asciz "EXIT"

    credit_intro:: .asciz "CREDITS"
    credit_text1:: .asciz "QUICO BLAZQUEZ"

    credit_text2:: .asciz "LUCILA VAZQUEZ"

    credit_text3:: .asciz "ALEXANDRU SULAR"

    credit_text4:: .asciz "Medusa_Projects"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_menu_selected:: .db 1

_menu_Status:: .db 0

.globl _effects

.globl _win_music

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN MENU
    man_menu_startmenu::
        ;; Renderizamos la pantalla principal
        call sys_render_main_screen

        call sys_render_menu_principal

        loop_wait_menu:

            call cpct_waitVSYNC_asm
            ; call cpct_akp_musicPlay_asm

            call sys_input_key_menu
            ld a,(_menu_selected)
            cp #0xFF                            ;; Si le da a el espacio, se sale
            jr z,end_loop_menu
            ld a,(_render_menu)
            or a
            jr z,loop_wait_menu                    ;; si cambia la pantalla, renderiza
            call sys_render_menu_principal     ;; Renderizamos la pantalla 
            xor a
            ld (_render_menu),a

            jr loop_wait_menu
            
        end_loop_menu:
        ld a,#1                 ;; Reiniciamos la seleccion
        ld (_menu_selected),a
        ld a,(_menu_Status)
        cp #1
        ret z           ;; Empieza el juego
        cp #2
        call z,man_menu_controls       ;; Empieza bucle guide
        cp #3
        call z,man_menu_credits
        cp #4
        ret z
        ;; Aqui van los otros menus

        jr man_menu_startmenu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GUIDE MENU
    man_menu_controls:

        call cpct_akp_stop_asm
        call sys_render_option_screen
        call sys_render_menu_control
        ld a,#1
        ld (_timer_teclas),a

        loop_wait_guide:

            call cpct_waitVSYNC_asm
            call sys_input_key_menu
            ld a,(_menu_selected)
            cp #0xFF                            ;; Si le da a el espacio, se sale
            jr z,end_loop_guide

            call sys_animation_controls_update
            jr loop_wait_guide
        end_loop_guide:
            ld a,#2
            ld (_menu_selected),a
            xor a
            ld (_menu_Status),a
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CREDITS MENU

 man_menu_credits:

        call sys_render_option_screen
        call sys_render_menu_credits

        loop_wait_credits:

            call cpct_waitVSYNC_asm
            call sys_input_key_menu
            ld a,(_menu_selected)
            cp #0xFF                            ;; Si le da a el espacio, se sale
            jr z,end_loop_credits
            
            jr loop_wait_credits
        end_loop_credits:
            ld a,#3
            ld (_menu_selected),a
            xor a
            ld (_menu_Status),a
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GAME OVER MENU
    man_menu_deathScreen::

        cpctm_clearScreen_asm #0x00 ; Pintamos pantalla en negro
        ld a,#50
        call sys_animation_death_menu
        ld a,#0
        loop_death_screen:
            call sys_input_key_menu
            ld a,(_menu_selected)
            cp #0xFF
            jr z,end_loop_death
            cp #2
            jr c,render_d_menu
                ld a,#2
                ld (_menu_selected),a
            render_d_menu:
            call sys_render_menu_death
            jr loop_death_screen
        end_loop_death:
        ld a,#1
        ld (_menu_selected),a
        ld a,(_menu_Status)
        cp #1
        jr z,retry_game
            ld a,#3
            ld (_game_STATUS),a
            ret
        retry_game:
        xor a
        ld (_game_STATUS),a
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Win Screen
    man_menu_WinScreen::
        call sys_render_option_screen
        call sys_render_win_screen
        ld de,#_win_music
        call cpct_akp_musicInit_asm
        loop_win_screen:
            call cpct_waitVSYNC_asm
            
            call sys_input_key_menu
            ld a,(_menu_selected)
            cp #0xFF
            jr z,end_loop_win
            ; call sys_animation_win_screen

        jr loop_win_screen
        end_loop_win:
        ld a,#2
        ld (_game_STATUS),a
        ret

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;