;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Template
;##################################################################################
    .area _CODE

    .include "manager/entity.inc"
    .include "manager/template.inc"
    .include "manager/animation.inc"
    .include "sprites/assets.inc"
    .include "system/ai.inc"


;##################################################################################


;##################################################################################
;## TEMPLATES ENTITIES
;##################################################################################

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; JUGADOR
    player_template:: 
        .db     e_type_player                   ;; type
        .db     player_cmps                     ;; components
        .db     36, 175                         ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     0                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_PLAYER_W                    ;; Width
        .db     SPR_PLAYER_H                    ;; Height
        .dw     _spr_player_00                  ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     #0x0000                         ;; IA
        .dw     #0x0000                         ;; action
        .dw     _worm_idle                      ;; animation
        .db     0x00                            ;; Anim Status
        .db     10,10                               ;; Anim count
        .dw     _worm_array                    ;; Anim_Table
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Enemy balloon
    enemy_balloon_template::
        .db     e_type_enemy_balloon                  ;; type
        .db     enemy_balloon_cmps              ;; components
        .db     8, 105                         ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     1                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_ENEMYSHOTER_W                   ;; Width
        .db     SPR_ENEMYSHOTER_H                   ;; Height
        .dw     _spr_desinflado_0                    ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     sys_ai_behaviour_enemy_balloon                         ;; IA
        .dw     #0x6400                         ;; action
        .dw     _balloon_small                         ;; animation
        .db     1                               ;; Anim Status
        .db     5,5                               ;; Anim count
        .dw     _balloon_array                          ;; Anim_Table
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMIGO DISPARA
    enemy_shoter_template::
        .db     e_type_enemy_shoter             ;; type
        .db     enemy_shoter_cmps               ;; components
        .db     8, 50                           ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     1                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_ENEMYSHOTER_W               ;; Width
        .db     SPR_ENEMYSHOTER_H               ;; Height
        .dw     _spr_enemyshoter_00              ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     sys_ai_behaviour_enemy_shoter   ;; IA
        .dw     #0x0000                         ;; action
        .dw     _shoter_right                   ;; animation
        .db     1                               ;; Anim Status
        .db     5,7                             ;; Anim count
        .dw     _shoter_array                   ;; Anim_Table

    enemy_shot_template::
        .db     e_type_shot                     ;; type
        .db     enemy_shot_cmps                 ;; components
        .db     15, 55                          ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     1                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_SHOT_W                      ;; Width
        .db     SPR_SHOT_H                      ;; Height
        .dw     _spr_shot_0                     ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     #0x0000                         ;; IA
        .dw     #0x0000                         ;; action
        .dw     _shot                           ;; animation
        .db     1                               ;; Anim Status
        .db     3,3                               ;; Anim count
        .dw     _shot_array            ;; Anim_Table

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ENEMIGO LARGO
    enemy_long_template::
        .db     e_type_enemy_long                ;; type    
        .db     enemy_long_cmps                  ;; components
        .db     8, 105                          ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     1                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_BIGSHOT_W                 ;; Width
        .db     SPR_BIGSHOT_H                  ;; Height
        .dw     _spr_bigshot_0                 ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     sys_ai_behaviour_long           ;; IA
        .dw     #0x0000                         ;; action
        .dw     #0x0000                         ;; animation  (tiempo que tarda en alargarse y desalargarse)
        .db     0                               ;; Anim Status (x anterior)
        .db     96                               ;; Anim count (y anterior)
        .dw     0x0000                          ;; Anim_Table


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Enemy lado
    enemy_lado_template::
        .db     e_type_enemy_lado                ;; type    
        .db     enemy_lado_cmps                  ;; components
        .db     28, 136                          ;; X, Y
        .db     0, 0                            ;; VX, VY
        .db     1                               ;; direction (1 right / -1 left / 2 up / -2 down)
        .db     SPR_ENEMYBASIC_W                  ;; Width
        .db     SPR_ENEMYBASIC_H                  ;; Height
        .dw     _spr_lado_a_lado_00               ;; Sprite
        .dw     #0x0000                         ;; prepvmem
        .dw     sys_ai_behaviour_enemybasic     ;; IA
        .dw     #0x0000                         ;; action
        .dw     _enemy_right                         ;; Animation
        .db     1                               ;; Anim Status
        .db     15,15                               ;; Anim count
        .dw     _enemy_array                          ;; Anim_Table
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



