;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Animations_System
;##################################################################################
    .area _CODE

    .include "cpctelera.h.s"
    .include "cpct_functions.inc"
    .include "manager/menu.inc"
    .include "system/render.inc"
    .include "sprites/assets.inc"
    .include "macros.inc"

;##################################################################################

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ANIMATIONS OUT OF GAMEPLAY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ANIMATION GAME OVER
    _death_text: .asciz "Retry? "
    sys_animation_death_menu::
        animation_death_loop:
        cp #28
        ret z
        ld hl,#0x0004
        push af
        call cpct_setDrawCharM0_asm
        pop af
        ld iy,#_death_text

        ld de,#CPCT_VMEM_START_ASM
        ld c,a
        ld b,#70
        push af
        call cpct_getScreenPtr_asm

        call cpct_drawStringM0_asm
        pop af
        dec a
        jr animation_death_loop

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ANIMATION GUIDE

    _timer_teclas:: .db 1
    _tecla_pulsada: .db 1
    sys_animation_controls_update::
        ld a, (_timer_teclas)
        dec a
        ld (_timer_teclas),a

        ld a, (_timer_teclas)
        cp #0
        ret nz
            ld a,(_tecla_pulsada)
            cp #0
            jr z, nomeilumino
                call sys_render_teclapulsada
                ld a, #0
                ld (_tecla_pulsada) , a
                ld a,#96
                ld (_timer_teclas) , a
                ret

        nomeilumino:    
           call sys_render_teclanopulsada
            ld a, #1
            ld (_tecla_pulsada) , a

            ld a,#96
            ld (_timer_teclas) , a
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Animation when checkpoint arrives
    _checkpoint_text: .asciz "CHECKPOINT "

    sys_animation_checkpoint::

        ld hl,#0x000F
        call cpct_setDrawCharM0_asm
        ld iy,#_checkpoint_text

        ld de,#CPCT_VMEM_START_ASM
        ld c,#20
        ld b,#50
        call cpct_getScreenPtr_asm

        call cpct_drawStringM0_asm

        ld de,#CPCT_VMEM_START_ASM
        ld c,#16
        ld b,#70
        call cpct_getScreenPtr_asm

        ex de,hl
        
        ld hl,#_spr_checkpoint
        ld c,#SPR_CHECKPOINT_W 
        ld b,#SPR_CHECKPOINT_H 
        call cpct_drawSprite_asm

        ld a,#150

        ld b,#5

        loop_checkpoint:
            push af
            push bc
            call cpct_waitVSYNC_asm
            pop bc
            pop af
            
            dec a
            cp #0
            jr nz,dec_timer
                ld a,b
                cp #0
                ret z
                dec b
                ld a,#150
                jr loop_checkpoint  
            dec_timer:

        jr loop_checkpoint

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Animation on win screen
    sys_animation_win_screen::

        ;; Time Finished num
        ld hl,#0x060F
        _animation_win_update::
        scf
        call c,set_color_time

        call cpct_setDrawCharM0_asm

        ld  iy,#_time_rendered

        ld de,#CPCT_VMEM_START_ASM
        ld c,#30
        ld b,#110
        call cpct_getScreenPtr_asm

        call cpct_drawStringM0_asm
        

    ret

    set_color_time:
        ld hl,#0x060D
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
