;##################################################################################################################
;##################################################################################################################
; Copyright (c) 2022 MedusaProjects | Quico Blázquez Vidal | Lucila Vázquez Soriano | Alexandru Carlos Sular Feier

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.
;##################################################################################################################
;##################################################################################################################

;##################################################################################
.module Physics_System
;##################################################################################
    .area _CODE

    .include "manager/entity.inc"
    .include "macros.inc"

;##################################################################################

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHYSICS UPDATE
    sys_physics_update::
        ld bc, #sys_physics_update_one_entity
        ld e, #e_cmp_movable
        call man_entity_forall_matching
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHYSICS UPDATE ONE ENTITY
    sys_physics_update_one_entity:
        ld a,e_type(ix)
        cp #e_type_player
        ret z
        ld a,e_posX(ix)
        add e_VX(ix)
        ld e_posX(ix),a

        ld a,e_posY(ix)
        add e_VY(ix)
        ld e_posY(ix),a

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PHYSICS UNDO LAST MOVEMENT
    sys_physics_undo_last_movement::
        ld a,e_posX(ix)
        sub e_VX(ix)
        ld e_posX(ix),a

        ld a,e_posY(ix)
        sub e_VY(ix)
        ld e_posY(ix),a

        ld a,e_type(ix)
        cp #e_type_enemy_long
        ret z
        
        ld a,e_type(ix)
        cp #e_type_enemy_lado
        ret z
        ld e_dir(ix),#0
        ld e_VX(ix),#0
        ld e_VY(ix),#0

    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Update physics player only
    sys_physics_update_player::

        call get_Player_entity_IX
        ld a,e_posX(ix)
        add e_VX(ix)
        ld e_posX(ix),a

        ld a,e_posY(ix)
        add e_VY(ix)
        ld e_posY(ix),a
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Update all entities - Player
    sys_physics_update_entities::
        _movement_update:
        scf
        call c,sys_physics_update
        ld a,(_movement_update)
        xor #0x80
        ld (_movement_update),a
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
